#emplacement de la machine virtuelle java
Sys.setenv(JAVA_HOME="/usr/lib/jvm/java-openjdk")

#emplacement de hadoop
Sys.setenv(HADOOP_HOME="/usr/lib/hadoop")
Sys.setenv(HADOOP_CMD="/usr/lib/hadoop/bin/hadoop")

#emplacement du jar se chargeant du streaming
Sys.setenv(HADOOP_STREAMING="/usr/lib/hadoop-mapreduce/hadoop-streaming-2.5.0-cdh5.3.0.jar")

library(rmr2)

#nouvelles options
bp <- list(
  hadoop = list(
    D = "mapreduce.map.java.opts=-Xmx1024M",
    D = "mapreduce.reduce.java.opts=-Xmx2048M",
    D = "mapreduce.map.memory.mb=1280",
    D = "mapreduce.reduce.memory.mb=2560"
  )
)

#modification
rmr.options(backend.parameters = bp)

#vérification
rmr.options("backend.parameters")

#mode hadoop
rmr.options(backend="hadoop")

#map function
mymap <- function(k,v){
  keyval(v,1)
}

myreduce <- function(k,v){
  n <- length(v)
  keyval(k,n)
}

#jeu de données créé en mémoire
b <- c("one","two","one","one","two")

#copié temporairement sur le système HDFS
a <- to.dfs(b)

#lancement
sortie <- mapreduce(input=a, map=mymap, reduce=myreduce)
print(from.dfs(sortie))
